# rsh-stats4ascript.tcl - by rehash
# Copyright (C) 2004, 2005 rehash.
# All rights reserverd.
# This is version 1.02
# Modifyed in 2006 to use with A&A script
#
# Description: This is the rsh-stats.tcl by rehash adapted to work 
# with A&A scripts (and not useing log files). 
# Creates a PHP-based channel statistics index. 
# And work with oher scripts like CHATstats 3.1.x by Baerchen.
#
# Demo at: http://bibliuta.lx.ro/Dana2006/
#            _            _
#    _ _ ___| |_  __ _ __| |_
#   | '_/ -_) ' \/ _` (_-< ' \
#   |_| \___|_||_\__,_/__/_||_|
#   rehash@relevant-undernet.org
#
#  Contact: E-mail: rehash@relevant-undernet.org
#  Web: www.relevant-undernet.org
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 1, or (at your option)
# any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
#
# This version is NOT includind the sendftp.tcl or the sendftp-win.tcl script
# but you can use that script if you whant.
# 
# You can set the timer or do the page manualy with dcc command .dopage
#
# Tip: If you uncoment some lines you can use the generated .php file as main 
# index for .htm pages generated with CHATstats 3.1.x by Baerchen.
#
# ( OryNider - Aug. 14 2006 )
##################################################################################

set settings(scriptname) "Channel We Statistics"

set stats_file "../Dana2006/index.php"

bind time - "30 % % % %" do_page
bind dcc n|- dopage do_page

proc do_page {{min ""} {hour ""} {day ""} {month ""} {year ""}} {
	global uptime version server serveraddress botnick botname stats_file template
	putlog "\[STATS\] Creating \[$stats_file\]..."

	append output "<?php function template() { ?>\n"
	append output "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"
	append output "<html xmlns=\"http://www.w3.org/1999/xhtml\">\n"
	append output "<head>\n"
	append output "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\" />\n"
	append output "<title>Channel &amp; Bot stats for $botnick</title>\n"

	append output "<style type=\"text/css\">\n"
	append output "body { padding: 0; margin: 0; font: 11px Verdana; background: #CCCCCC; }\n"
	append output "td.main { border: 1px solid #3333FF; padding: 5px; }\n"
	append output "td.stat { background: #cccccc; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 5px;}\n"
	append output "td.nav { background: #888888; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 5px; color: #CCC333; font-weight: bold;}\n"
	append output "td.navmenu { background: #888888; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 2px; color: #33CC33; font-weight: bold;}\n"
	append output "span.chan { padding: 1px 0 1px 2px; color: #CC3333; font-weight: bold;}\n"
	append output "span.chan2 { padding: 1px 0 1px 2px; color: #33CCFF; font-weight: bold;}\n"
	append output "span.chan3 { padding: 1px 0 1px 2px; color: #CCC333; font-weight: bold;}\n"
	append output "td.bla { background: #dddddd; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 5px; color: #3366FF; font-weight: bold;}\n"
	append output "td.link { background: #777777; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 5px;}\n"
	append output "td.link:hover { background: #D5D9D8; border-top: 1px solid #FFFFFF; border-bottom: 1px solid #859288; padding: 1px 0 1px 5px; }\n"
	append output "a.link { color: #000000; text-decoration: none; font-weight: bold;}\n"
	append output "a.link:hover { color: #3333FF; text-decoration: underline;}\n"
	append output "h3 { margin: 10px; font: 16px Arial; font-weight: bold}\n"
	append output "p { margin: 0; font: 12px Verdana; padding: 2px;}\n"
	append output "</style>\n"
	append output "</head>\n"

	append output "<body>\n"
	append output "<table width=\"100%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
	append output "  <tr>\n"
	append output "    <td height=\"50\">&nbsp;</td>\n"
	append output "  </tr>\n"
	append output "</table>\n"

	append output "<table width=\"100%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
	append output " <TBODY>\n"
	append output "  <tr>\n"
	append output "    <td width=\"1%\">&nbsp;</td>\n"
	append output "    <td width=\"98%\">\n"
	append output "	<table width=\"100%\"  border=\"0\" cellspacing=\"2\" cellpadding=\"0\">\n"
        append output "  <TBODY>\n"
	append output "	  <tr>\n"
	append output "	    <td width=\"20%\" valign=\"top\">\n"
	append output "		<table width=\"100%\"  border=\"0\" cellspacing=\"0\" cellpadding=\"0\">\n"
        append output "          <TBODY>\n"
	append output "		  <tr>\n"
	append output "		    <td class=\"navmenu\" width=\"120\"><h3>&raquo; <span class=\"chan2\">N</span><span class=\"chan3\">avigation</span></h3></td>\n"
	append output "		  </tr>\n"
	append output "<tr><td class=\"link\"><a href=\"$::stats_file\" class=\"link\" style=\"display: block;\">Home</a></td></tr>\n"


	set i 0
	foreach ch [channels] {
	 if {![string equal -nocase $::settings(homechan) $ch]} {
		incr i
		append output "<tr><td class=\"link\"><a href=\"?schan=$i\" class=\"link\" style=\"display: block;\">$ch</a></td></tr>\n"
	 }
	}

	append output "		</table>\n"
	append output "		</td>\n"
		
	append output "    	<td width=\"80%\" height=\"400\" valign=\"top\" class=\"main\">\n"
	append output "		<? content(); ?>\n"
	append output "		</td>\n"
	append output "	  </tr>\n"
	append output "	  <tr>\n"
	append output "	  	<td width=\"20%\">&nbsp;</td>\n"
	append output "		<td width=\"80%\">Copyright &copy; rehash 2005. ALL rights reserved</td>\n"
	append output "	  </TBODY>\n"
	append output "	  </tr>\n"
	append output "	</table>\n"
	append output "	</td>\n"
	append output "    <td width=\"10%\">&nbsp;</td>\n"
	append output "  </tr>\n"
	append output "</TBODY>\n"
	append output "</table>\n"


	append output "</body>\n"
	append output "</html>\n"
	append output "<? } ?>\n"

	append output "<?\n"
	append output "\$p = \$_GET\['schan'\];\nswitch (\$p) \{\n"
	set j 0
	foreach c [channels] {
	  if {![string equal -nocase $::settings(homechan) $c]} {
		incr j
		append output "\tcase '$j':\n\t\tschan_$j\();\n\t\tbreak;\n"
	  }
	}
	append output "\tdefault:\n\t\thome();\n"
	append output "\}\n"

	append output "function home\() \{\n"
	append output "\tfunction content\() \{\n"
	global uptime version server serveraddress botnick botname
	set tim [ctime $uptime]
	set chans [channels]
	set usrs [countusers]
	set i 0
	foreach ch $chans { if {![string equal -nocase $ch $::settings(homechan)]} { incr i }}
	append output "\t\techo '<center>$botnick: $i channel(s), $usrs user(s).<br />';\n"
	append output "\t\techo 'Online Since: $tim<br />';\n"
	append output "\t\techo 'Bot Nick: $botnick<br />';\n"
	append output "\t\techo 'Bot Name: $botname<br />';\n"
	append output "\t\techo 'Eggdrop Version: [lindex $version 0]<br />';\n"
	append output "\t\techo 'Script Version: $::settings(version) $::settings(scriptname)<br />';\n"
	append output "\t\techo 'Connected to server: [lindex [split $server :] 0]<br />';\n"
	append output "\t\techo 'Server DNS: [lindex [split $serveraddress :] 0]</center> <br />';\n"

	append output "\t\}\n\ttemplate\();\n"
	append output "\}\n\n"
	set k 0
	foreach h [channels] {
	  if {![string equal -nocase $::settings(homechan) $h]} {
		incr k
		append output "function schan_$k\() \{\n"
		append output "\tfunction content\() \{\n"
		append output "\t\tif (!isset\(\$_GET\['logs'\])) \{\n"

		set users [chanlist $h]
		set modes [getchanmode $h]
		set bans [chanbans $h]
		set user "0"
		set n "0"
		set ops "0"
		set voice "0"
		set none "0"
		set ban_nr "0"
		set stick "no"
		foreach name $users {
                       if {[isop $name $h]} { incr ops } elseif {
			   [isvoice $name $h]} { incr voice } else { incr none }
                       incr n
		}
		append output "\t\t\techo '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">';\n"
		append output "\t\t\techo '<TBODY>';\n"
		append output "\t\t\techo '<tr><td class=\"nav\"><h3>Chan stats for <span class=\"chan2\">$h</span> [ctime [unixtime]] </h3></td></tr>';\n"
		# append output "\t\t\techo '<tr><td class=\"link\"><a target=\"_blank\" href=chanstats.[string tolower [string range $h 1 end]].htm class=\"link\" style=\"display: block;\"><b>Channel Statistics.</b></a></td></tr>';\n"
		# append output "\t\t\techo '<tr><td class=\"link\"><a target=\"_blank\" href=botstats.[string tolower [string range $h 1 end]].htm class=\"link\" style=\"display: block;\"><b>Bot Statistics.</b></a></td></tr>';\n"
		# append output "\t\t\techo '<tr><td class=\"link\"><a target=\"_blank\" href=otherstats.[string tolower [string range $h 1 end]].htm class=\"link\" style=\"display: block;\"><b>Other Statistics.</b></a></td></tr>';\n"
		# append output "\t\t\techo '<tr><td class=\"link\"><a target=\"_blank\" href=toptalls.[string tolower [string range $h 1 end]].htm class=\"link\" style=\"display: block;\"><b>TopTalkers & AllStars for $h.</b></a></td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">I\`m currently in this channel.</td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\"><b>Channel <span class=\"chan\">$h</span></b> has $n</b> users ($ops operator(s))</td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\"><b>Channel Modes</b>: $modes</td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\"><b>Channel Ban List</b>:</td></tr><tr><td class=\"bla\">';\n"
		if {$bans == ""} { append output "\t\t\techo '<p>No bans in <b><span class=\"chan\">$h</span></b> ban list!</p>';\n" }
		foreach ban $bans {
			incr ban_nr
			if {[isbansticky $ban $h] == 1} { set stick "yes" }
			append output "\t\t\techo '<p>   $ban : \[Sticky: $stick\]</p>';\n"
		}
		# set chan $h
		# append output "\t\t\techo '<tr><td class=\"stat\"><b>Topic</b>: [topic $chan]</td></tr>';\n"
		append output "\t\t\techo '</td></tr></table>';\n"

		append output "\t\t\techo '<table border=\"0\"><tr><td height=\"10\">&nbsp;</td></tr></table>';\n"

		append output "\t\t\techo '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">';\n"
                append output "\t\t\techo '<TBODY>';\n"
		append output "\t\t\techo '<tr><td colspan=\"4\" class=\"nav\"><h3>User stats</h3></td>';\n"
		append output "\t\t\techo '<tr><td width=\"25%\" class=\"stat\"><b>Total Ops</b>: $ops.</td>';\n"
		append output "\t\t\techo '<td width=\"25%\" class=\"bla\"><b>Total Voice</b>: $voice.</td>';\n"
		append output "\t\t\techo '<td width=\"25%\" class=\"stat\"><b>Total Normal</b>: $none.</td>';\n"
		append output "\t\t\techo '<td width=\"25%\" class=\"bla\"><b>Total Users</b>: $n.</td>';\n"
		append output "\t\t\techo '</table>';\n"
                append output "\t\t\techo '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">';\n"
                append output "\t\t\techo '<TBODY>';\n"
		append output "\t\t\techo '</tr><tr><td width=\"100%\" class=\"stat\"><center><b><u>Currently on chan: </u></b><br>[join [chanlist $h] ", "]. </td></tr>';\n"
		append output "\t\t\techo '</table>';\n"

		append output "\t\t\techo '<table border=\"0\"><tr><td height=\"10\">&nbsp;</td></tr></table>';\n"
		
		
		
		append output "\t\t\techo '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">';\n"
                append output "\t\t\techo '<TBODY>';\n"
		append output "\t\t\techo '<tr><td class=\"nav\"><h3>ADMINS.</h3></td></tr>';\n"

		set chan $h

		set manager    ""
		set owner      ""
		set master     ""
		set op         ""
		set halfop     ""
		set voice      ""
		foreach w [userlist |lvonmN $chan] {
			if {[matchattr $w |N $chan]} {lappend manager "$w"} elseif {
			    [matchattr $w |n $chan]} {lappend owner "$w"} elseif {
			    [matchattr $w |m $chan]} {lappend master "$w"} elseif {
			    [matchattr $w |o $chan]} {lappend op "$w"} elseif {
			    [matchattr $w |l $chan]} {lappend halfop "$w"} else {
 			    lappend voice "$w"
			}
		}

if {[llength $manager]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Manager: [join $manager ", "]</td></tr>';\n"}
if {[llength $owner]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Owners: [join $owner ", "]</td></tr>';\n"}
if {[llength $master]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Masters: [join $master ", "]</td></tr>';\n"}
if {[llength $op]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Ops: [join $op ", "]</td></tr>';\n"}
if {[llength $halfop]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Halfops: [join $halfop ", "]</td></tr>';\n"}
if {[llength $voice]}	{ append output "\t\t\techo '<tr><td class=\"stat\">Voices: [join $voice ", "]</td></tr>';\n"}

		append output "\t\t\techo '<table border=\"0\"><tr><td height=\"10\">&nbsp;</td></tr></table>';\n"

		append output "\t\t\techo '<table border=\"0\" cellspacing=\"0\" cellpadding=\"0\" width=\"100%\">';\n"
                append output "\t\t\techo '<TBODY>';\n"
		append output "\t\t\techo '<tr><td class=\"nav\"><h3>All Stats.</h3></td></tr>';\n"

		
		set chan $h
		append output "\t\t\techo '<tr><td class=\"stat\">Slap: [iif [llength [::stats::channel -get $chan slap]] [::stats::channel -get $chan slap] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">F*ck: [iif [llength [::stats::channel -get $chan fuck]] [::stats::channel -get $chan fuck] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Kiss: [iif [llength [::stats::channel -get $chan kiss]] [::stats::channel -get $chan kiss] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Mail: [iif [llength [::stats::channel -get $chan mail]] "<a href=\"mailto:[::stats::channel -get $chan mail]\">[::stats::channel -get $chan mail]</a>" Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Url: [iif [llength [::stats::channel -get $chan url]] "<a href=\"[::stats::channel -get $chan url]\">[::stats::channel -get $chan url]</a>" Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Faq: [iif [llength [::stats::channel -get $chan faq]] [::stats::channel -get $chan faq] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">News: [iif [llength [::stats::channel -get $chan news]] [::stats::channel -get $chan news] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Rules: [iif [llength [::stats::channel -get $chan rules]] [::stats::channel -get $chan rules] Off]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">TopicText: [iif [llength [::stats::channel -get $chan topictext]] [::stats::channel -get $chan topictext] Off]. </td></tr>';\n"
		
		
		append output "\t\t\techo '<tr><td class=\"stat\">Total Joins: [::stats::channel -get $chan joins]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Topics: [::stats::channel -get $chan topics]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Traffic: [::stats::channel -get $chan traffic] lines.</td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Traffics: [::stats::channel -get $chan traffics] lines.</td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">MaxUsers: [::stats::channel -get $chan maxusers]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Bans: [::stats::channel -get $chan bans]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Kicks: [::stats::channel -get $chan kicks]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Deops: [::stats::channel -get $chan deops]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Ops: [::stats::channel -get $chan ops]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Devoices: [::stats::channel -get $chan devoices]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Voices: [::stats::channel -get $chan voices]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Me Banned: [::stats::channel -get $chan banned]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Me Deopped: [::stats::channel -get $chan deopped]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Me Kicked: [::stats::channel -get $chan kicked]. </td></tr>';\n"
		append output "\t\t\techo '<tr><td class=\"stat\">Total Time Spent There: [duration [::stats::channel -get $chan time]].</td></tr>';\n"

		append output "\t\t\techo '</TBODY>';\n\n"
		append output "\t\t\techo '</table>';\n\n"
		append output "\t\t\}\n"
		append output "\t\}\n\t template\();\n"
		append output "\}\n\n"
	 }
	}
	append output "?>"

	# Writing the web page!!
	# CODE!
	set page [open $stats_file w]
	puts $page $output
	close $page

	putlog "\[STATS\] \[$stats_file\] was succesfully created!"
}

putlog "Loading Channel Statistics - by rehash"
